Summary: HTTP server daemon with SSL
Name: apache-ssl
%define apachever 1.3.11
%define apachesslver 1.38
Version: %{apachever}_%{apachesslver}
# Serial number taken from APACHE_RELEASE definition in src/include/httpd.h
# Update Serial Number when Apache version is changed.
Serial: 10311100
Release: 2
Group: Networking/Daemons
Source0: ftp://ftp.apache.org/apache/dist/apache_%{apachever}.tar.gz
Source1: ftp://ftp.ox.ac.uk/pub/crypto/SSL/apache_%{apachever}+ssl_%{apachesslver}.tar.gz
Source2: httpsd.init
Source3: httpsd.log
Source4: gendummycerts
Source5: httpsd.conf
Source6: SmallSSL.gif
Source7: index.html
Source8: poweredby.gif
Source9: server.crt
Source10: server.csr
Source11: server.key
Patch0: configuration.patch
Copyright: BSD-like
Obsoletes: apache-suexec apache-extra apache-doc
Provides: apache-ssl securewebserver
BuildRoot: /var/tmp/apache-ssl
Requires: initscripts >= 3.25
Requires: openssl >= 0.9.4 
Prereq: /sbin/chkconfig
URL: http://www.apache-ssl.org/
Packager: Greg Wright <greg@ausit.com>
Distribution: RedHat 6.1

%description
Apache is a full featured web server that is freely available, and also
happens to be the most widely used.

Apache-SSL adds support for SSL. Do not export from the U.S.

You can now run Apache-SSL and bulk Redhat Apache at the same time.

ABuilt with loadable modules (all standard modules enabled).
This verion is intended as a replacement for a standard apache, the
configuration files provided with apache and apache-ssl are unchanged.

Built for glibc2.1 on RedHat 6.1.

#%package devel
#Group: Networking/Daemons
#Summary: Header files from apache for developing/compiling 3rd party modules
#Obsoletes: secureweb-devel
#
#%description devel
#This package includes the source code and for Apache 1.3.4, as well as the
#'apxs' binary for building dynamic shared objects (DSOs).  This package needs
#to be installed if you want to compile or develop additional modules for
#Apache.

%prep 
%setup -b0 -a1 -n apache_%{apachever}
patch -p0 < SSLpatch
%patch0 -p0

%build

OPTIM="$RPM_OPT_FLAGS" ./configure \
	--without-confadjust \
	--prefix=/home/httpsd \
	--sysconfdir=/etc/httpsd/conf \
	--mandir=/usr/man \
	--sbindir=/home/httpsd/sbin \
	--includedir=/usr/include/apache \
	--disable-rule=WANTHSREGEX \
	--datadir=/home/httpsd \
	--localstatedir=/var \
	--runtimedir=/var/run \
	--logfiledir=/var/log/httpsd \
	--libexecdir=/home/httpsd/libexec \
	--suexec-docroot=/home/httpsd/html \
	--enable-module=all \
	--enable-shared=max \
	--enable-suexec --suexec-caller=nobody \
	--suexec-uidmin=500 --suexec-gidmin=500

make

%install
rm -rf $RPM_BUILD_ROOT
make install-quiet root="$RPM_BUILD_ROOT"

# remove httpsdctl; we have our own SYSV init stuff
rm $RPM_BUILD_ROOT/home/httpsd/sbin/httpsdctl

# move httpsd to /usr/sbin
mkdir -p $RPM_BUILD_ROOT/usr
mkdir -p $RPM_BUILD_ROOT/usr/sbin
install $RPM_BUILD_ROOT/home/httpsd/sbin/httpsd $RPM_BUILD_ROOT/usr/sbin

# rename the html directory
mv $RPM_BUILD_ROOT/home/httpsd/htdocs $RPM_BUILD_ROOT/home/httpsd/html

# intro page stuff
install $RPM_SOURCE_DIR/SmallSSL.gif $RPM_BUILD_ROOT/home/httpsd/icons
install $RPM_SOURCE_DIR/poweredby.gif $RPM_BUILD_ROOT/home/httpsd/html
install $RPM_SOURCE_DIR/index.html $RPM_BUILD_ROOT/home/httpsd/html

mkdir -p $RPM_BUILD_ROOT/etc/{logrotate.d,rc.d/init.d}
mkdir -p $RPM_BUILD_ROOT/var/spool/proxy
mkdir -p $RPM_BUILD_ROOT/home/httpsd
mkdir -p $RPM_BUILD_ROOT/home/httpsd/cache
install $RPM_SOURCE_DIR/httpsd.log $RPM_BUILD_ROOT/etc/logrotate.d/httpsd
install $RPM_SOURCE_DIR/httpsd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/httpsd
install $RPM_SOURCE_DIR/httpsd.conf  $RPM_BUILD_ROOT/etc/httpsd/conf/httpsd.conf
install $RPM_BUILD_DIR/apache_%{apachever}/SSLconf/conf/ssleay.cnf \
	$RPM_BUILD_ROOT/etc/httpsd/conf
install $RPM_BUILD_DIR/apache_%{apachever}/SSLconf/conf/httpd.conf \
	$RPM_BUILD_ROOT/etc/httpsd/conf/httpd.conf.ssl
mkdir -p $RPM_BUILD_ROOT/home/httpsd/sbin

ls $RPM_BUILD_ROOT/etc/httpsd/conf/

mkdir -p $RPM_BUILD_ROOT/etc/httpsd/conf/certs
install $RPM_BUILD_DIR/apache_%{apachever}/src/modules/ssl/gcache $RPM_BUILD_ROOT/home/httpsd/sbin
install $RPM_SOURCE_DIR/gendummycerts $RPM_BUILD_ROOT/usr/sbin

install $RPM_SOURCE_DIR/server.crt \
	$RPM_BUILD_ROOT/etc/httpsd/conf/certs/server.crt
install $RPM_SOURCE_DIR/server.csr \
	$RPM_BUILD_ROOT/etc/httpsd/conf/certs/server.csr
install $RPM_SOURCE_DIR/server.key \
	$RPM_BUILD_ROOT/etc/httpsd/conf/certs/server.key

# remove perl5 deps
find $RPM_BUILD_ROOT -type f -exec /usr/bin/perl -e 's/^#!\/usr\/local\/bin\/perl5/#!\/usr\/bin\/perl/gi' -p -i \{\} \;

%clean
rm -rf "$RPM_BUILD_ROOT"

%post
echo "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
echo "@ Don't forget to do a gendummycerts after installation @"
echo "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"

/sbin/chkconfig --add httpsd

%preun
if [ $1 = 0 ]; then
   if [ -f /var/lock/subsys/httpsd ]; then
       /etc/rc.d/init.d/httpsd stop
   fi
   /sbin/chkconfig --del httpsd
fi

%files
%defattr(644 root root 755)
%attr(755,root,root)  %dir /etc/httpsd
%attr(755,root,root)  %dir /etc/httpsd/conf
%attr(644,root,root)  %config /etc/httpsd/conf/*
%attr(644,root,root)  %config /etc/logrotate.d/*
%attr( - ,root,root)  %doc ABOUT_APACHE src/CHANGES KEYS LICENSE README
%attr( - ,root,root)  %doc CHANGES.SSL EXTRAS.SSL LICENCE.SSL README.SSL
%attr( - ,root,root)  %doc SECURITY md5sums md5sums.asc
%attr( - ,root,root)  %doc src/support/suexec.[ch]
%attr(755,root,root)  %dir /home/httpsd
%attr(755,root,root)  %dir /home/httpsd/html
%attr(644,root,root)  %config /home/httpsd/html/index.html
%attr(644,root,root)  %config /home/httpsd/html/poweredby.gif
%attr(755,root,root)  /etc/rc.d/init.d/*
%attr( - ,root,root)  /home/httpsd/cgi-bin
%attr( - ,root,root)  /home/httpsd/icons
%attr( - ,root,root)  /home/httpsd/libexec/*
%attr(755,root,root)  /home/httpsd/bin/*
%attr(755,root,root)  /home/httpsd/sbin/ab
#%attr(755,root,root)  /home/httpsd/sbin/httpsdctl
%attr(755,root,root)  /home/httpsd/sbin/apxs
%attr(755,root,root)  /home/httpsd/sbin/gcache
%attr(755,root,root)  /home/httpsd/sbin/logresolve
%attr(755,root,root)  /home/httpsd/sbin/rotatelogs
%attr(4755,root,root) /home/httpsd/sbin/suexec
%attr(755,root,root)  /usr/sbin/gendummycerts
%attr(755,root,root)  /usr/sbin/httpsd
#%attr(644,root,root)  /usr/man/man1/*
%attr(644,root,root)  /usr/man/man8/httpsd.8
%attr(755,root,root)  %dir /var/log/httpsd
%attr(755,root,root)  %dir /var/spool/proxy
%attr(755,root,root)  %dir /home/httpsd/cache
%attr( - ,root,root)  %docdir /home/httpsd/html/manual
%attr( - ,root,root)  /home/httpsd/html/manual

#%files devel
#%defattr(-,root,root)
#/usr/include/apache
#/usr/sbin/apxs
#/usr/src/apache_%{version}

%changelog
* Thu Dec 5 1999 Greg Wright <greg@ausit.com> & Henri Gomez <gomez@slib.fr>
[1.3.9-1.37-2]
Added patched httpsd.conf, added install of dummy certs

* Thu Dec 2 1999 Henri Gomez <gomez@slib.fr> & Greg Wright <greg@ausit.com>
[1.3.9-1.37-1]
Corrected perl5 path, Greg Wright changed OpenSSL req to 0.9.4

* Wed Dec 1 1999 Henri Gomez <gomez@slib.fr>
- Adapted for apache 1.3.9 + apachessl 1.3.7
- Removed mod_rewrite patch

* Mon Jun 7 1999 Greg LaPolla
- Modified for the openssl rpm, apache 1.3.6, & apachessl-1.35

* Tue Jan 26 1999 Henri Gomez
[1.3.4-1.31-1]
Upgraded to 1.31
Do no replace your standard RH Apache Server
Run as httpsd so totally independant from standard httpd
Data goes in /home/httpsd, conf in /etc/httpsd/conf and logs in /var/log/httpsd
Added /etc/httpsd/conf/certs as certificates repository and dummy certs generation at install time
fixed libexec to /home/httpsd/libexec instead /home/httpd/libexec
binaries now in /home/httpsd/sbin instead of /home/httpd/sbin
docdir in /home/httpsd/html instead of /home/httpd/htdocs

* Fri Jan 22 1999 Henri Gomez
[1.3.4-1.30]
Make SSLeay needed since no OpenSSL RPM available yet

* Thu Jan 21 1999 Henri Gomez
[1.3.3-1.29] 
Upgraded to 1.29 

* Sun Oct 25 1998 Magnus Stenman
[1.3.3-1.28]
New versions of apache and apache-ssl

* Sun Oct 11 1998 Magnus Stenman
[1.3.2-1.27]
first release, based on
apache-1.3.1-1.src.rpm by Manoj Kasichainula <manojk@io.com>

This version is intended to replace a standard non-ssl apache.

